---
Name: sledgehammer-exablaze-current-drivers
Description: Install updated Exablaze drivers in Sledgehammer
Documentation: |
  This task installs up-to-date Exablaze drivers from the source
  repo defined in the `sledgehammer/exablaze-driver-repo` param.

  This task is not included in Sledgehammer by default -- to include it,
  add it to `sledgehammer/customize-tasks` and rebuild Sledgehammer.

  Please note that a Sledgehammer image built using this task will not
  be compatible with UEFI Secure Boot, as the resulting kernel modules
  will not be signed by the CentOS signing authority.

  !!! warning
      THIS DOES NOT WORK BECAUSE DKMS IS NOT FUNCTIONAL IN SLEDGEHAMMER.
      NEED SOURCE STYLE FOR THIS.

Templates:
  - Name: install-exablaze-drivers
    Contents: |
      #!/bin/bash
      {{ template "setup.tmpl" . }}
      mkdir -p /tmp/exablaze-install
      cd /tmp/exablaze-install
      repo='{{.Param  "sledgehammer/exablaze-driver-repo"}}'

      cat > /etc/yum.repos.d/exablaze.repo <<EOF
      [exablaze-8]
      name=exablaze8
      gpgcheck=0
      baseurl={{.Param "sledgehammer/exablaze-driver-repo"}}
      EOF

      [[ -e preinstalled ]] || rpm -qa >preinstalled
      dnf -y install kernel-rpm-macros \
          kernel-devel \
          make \
          rpm-build \
          lsof \
          gcc \
          elfutils-libelf-devel \
          dkms \
          kernel-headers

      # Fix header link.
      installed_kernel=$(ls /lib/modules)
      current_kernel=$(uname -r)
      if [[ "$installed_kernel" != "$current_kernel" ]] ; then
        cd /lib/modules
        ln -s $installed_kernel $current_kernel
        cd -
      fi

      # DKMS magic and more
      dnf -y install exanic

      # Save of driver.
      mkdir -p /tmp/exadrivers
      find /lib/modules | grep exanic | grep -v weak | while read file
      do
        cp --parents -P $file /tmp/exadrivers
      done
      find /lib/modules | grep exasock | grep -v weak | while read file
      do
        cp --parents -P $file /tmp/exadrivers
      done

      # Remove header link
      if [[ "$installed_kernel" != "$current_kernel" ]] ; then
        cd /lib/modules
        rm $current_kernel
        cd -
      fi

      # Clean up crap
      rpm -qa >postinstalled
      sort preinstalled postinstalled |uniq -u | xargs rpm -e

      # Put drivers back
      cp -r /tmp/exadrivers /
      rm -rf /tmp/exadrivers

      # Install exanic utils
      dnf -y install exanic-utils
